routes/web.php
<?php

use App\Http\Controllers\Admin\ComplaintController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\ReviewController;
use App\Http\Controllers\Admin\ScientistController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\Route;

use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\RoleController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [HomeController::class, 'index'])->name('home');

Route::group( ["prefix" => "panel" ], function() {
    Route::get('', [HomeController::class, 'adminIndex'])->name('admin.admin.index');

    Route::get('login', [LoginController::class, 'showLoginForm'])->name('admin.login.show');
    Route::post('login', [LoginController::class, 'login'])->name('admin.login');

    Route::group( ["prefix" => "profile" ], function() {
        Route::get('/show', [ProfileController::class, 'show'])->name('profile.show');
        Route::get('/edit', [ProfileController::class, 'edit'])->name('profile.edit');
        Route::put('/edit', [ProfileController::class, 'update'])->name('profile.update');

    });

    Route::group(["prefix" => "user_management"], function (){
        Route::resource('roles', RoleController::class);
        Route::resource('users', UserController::class);
        Route::post('users/{id}/moderate', [UserController::class, 'moderate'])->name('users.moderate');
    });

    Route::resource('reviews', ReviewController::class)->only('index', 'show', 'edit', 'destroy');
    Route::post('/review/{complaint}/decline', [ReviewController::class, 'decline'])->name('review.decline');
    Route::post('/review/{complaint}/accept', [ReviewController::class, 'accept'])->name('review.accept');

    Route::get('scientists', [ScientistController::class, 'index'])->name('scientists.index');
    Route::get('scientists/{id}/reviews', [ScientistController::class, 'show'])->name('scientists.show');

    Route::get('complaint', [ComplaintController::class, 'index'])->name('complaints.index');

});

Route::group(['prefix' => 'ajax'], function($router) {



});

app/Models/Complaint.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

/**
 * App\Models\Complaint
 *
 * @property int $id
 * @property string $model_type
 * @property int $model_id
 * @property int $user_id
 * @property string $body
 * @property int $status
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @property-read \App\Models\User|null $fromUser
 * @property-read \App\Models\User|null $toUser
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint query()
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereBody($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereModelId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereModelType($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereStatus($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereUpdatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereUserId($value)
 * @mixin \Eloquent
 * @property int $review_id
 * @property string $text
 * @property int $closed
 * @property-read Model|\Eloquent $related
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereClosed($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereReviewId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Complaint whereText($value)
 */
class Complaint extends Model
{
    use HasFactory;

    protected $guarded = [];

    public function fromUser()
    {
        return $this->hasOne(User::class, 'id', 'user_id');
    }

    public function toUser()
    {
        return $this->hasOne(User::class, 'id', 'to_user_id');
    }

    public function related()
    {
        return $this->morphTo('model','model_type','model_id', 'id');
    }
}

app/Http/Controllers/Admin/ComplaintController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Complaint;
use Illuminate\Http\Request;

class ComplaintController extends Controller
{
    public function index(Request $request)
    {
        if ($request->status && $request->status != 'all'){
            $complaints = Complaint::where('status', $request->status)->with('related')->get();
        }else
            $complaints = Complaint::with('related')->get();

        return view('admin.complaint.index', compact('complaints'));
    }
}

app/Http/Controllers/ComplaintController.php
<?php

namespace App\Http\Controllers;

use App\Models\Complaint;
use Illuminate\Http\Request;

class ComplaintController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Complaint  $complaint
     * @return \Illuminate\Http\Response
     */
    public function show(Complaint $complaint)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Complaint  $complaint
     * @return \Illuminate\Http\Response
     */
    public function edit(Complaint $complaint)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Complaint  $complaint
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Complaint $complaint)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Complaint  $complaint
     * @return \Illuminate\Http\Response
     */
    public function destroy(Complaint $complaint)
    {
        //
    }
}

resources/views/admin/complaint/index.blade.php
@include('admin.layouts.header')

<div class="container container-fluid">
    <div class="title-block">
        <div class="row row--multiline">
            <div class="col-md-4">
                <h1 class="title-primary" style="margin-bottom: 0">Complaints</h1>
            </div>
            <div class="col-md-8 text-right-md text-right-lg">

                <div class="flex-form center">
                    <form class="input-button" action="{{ route('complaints.index') }}" method="GET">

                        <select name="status" class="chosen no-search input-regular" data-placeholder="All" required>
                            <option class="hidden" value="all" hidden>Все</option>

                            <option value="all" {{request('status') === 'all' ? 'selected' :''}} >All</option>
                            <option value="1" {{request('status') == '1' ? 'selected' :''}} >Approved</option>
                            <option value="0" {{request('status') == '0' ? 'selected' :''}} >Under consideration</option>
                            <option value="-1" {{request('status') == '-1' ? 'selected' :''}} >Rejected</option>
                        </select>

                        <button class="btn btn--green">Apply</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <div class="block">
        <h2 class="title-secondary">List of Complaints</h2>
        <table class="table records">
            <colgroup>
                <col span="1" style="width: 3%;">
                <col span="1" style="width: 20%;">
                <col span="1" style="width: 12%;">
                <col span="1" style="width: 20%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 15%;">
            </colgroup>
            <thead>
                <tr>
                    <th>ID</th>
                    <th>From</th>
{{--                    <th>To</th>--}}
                    <th>Status</th>
                    <th>Date of creation</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
            @foreach($complaints as $complaint)
                <tr>
                    <td>{{ $complaint->id }}</td>
                    <td>{{ $complaint->fromUser->name }}</td>
{{--                    <td>{{ $complaint->model->toUser->name }}</td>--}}
                    <td>
                        @if ($complaint->status === 1)
                            Approved
                        @elseif ($complaint->status === -1)
                            Rejected
                        @else
                            Under consideration
                        @endif
                    </td>
                    <td>{{ $complaint->created_at }}</td>
                    <td>
                        <div class="action-buttons">
                            <a href="{{ route('reviews.show', $complaint->id) }}" title="Посмотреть" class="icon-btn icon-btn--green icon-eye"></a>
                            <a href="{{ route('reviews.edit', $complaint->id) }}" title="Редактировать" class="icon-btn icon-btn--yellow icon-edit"></a>
                            <a href="javascript:;" title="Удалить" onclick="document.querySelector('#model-{{ $complaint->id }}').submit()" class="icon-btn icon-btn--pink icon-delete"></a>
                            <form action="{{ route('reviews.destroy', $complaint->id) }}" id="model-{{ $complaint->id }}" method="post">
                                @csrf
                                @method('delete')
                            </form>
                        </div>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>

        <div class="text-right">
            <ul class="pagination">
                <li class="previous_page disabled"><span><i class="icon-chevron-left"></i></span></li>
                <li class="active"><a href="#">1</a></li>
                <li><a href="#">2</a></li>
                <li><a href="#">3</a></li>
                <li><a href="#">4</a></li>
                <li><a href="#">5</a></li>
                <li class="dots disabled"><span>...</span></li>
                <li><a href="#">498</a></li>
                <li><a href="#">499</a></li>
                <li class="next_page"><a href="#"><i class="icon-chevron-right"></i></a></li>
            </ul>
        </div>
    </div>

@extends('admin.layouts.footer')
@section('content')
    <!--Only this page's scripts-->
    <!---->
@endsection